/***************************************************************************
                          adressbuch.cpp  -  description                              
                             -------------------                                         
    begin                : 10.11.1999                                          
    copyright            : (C) 1999 by Christoph Maciejewski                   
    email                : christophmac@01019freenet.de
                  
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "adressbuch.h"
#include <kprocess.h>


Adressbuch::~Adressbuch()
{

}



void Adressbuch::information()
{
   info = new QMessageBox( "Info", "Adressbuch 1.0 \nBy Christoph Maciejewski 1999\nchristophmac@01019freenet.de",
                           QMessageBox::Information,
                           0, 0, 0, this, "info");

   info->show();


}

void Adressbuch::boxinhalt()
{
   int i;
   QDir d(".");
   d.setNameFilter("*.chr");
   box->clear();

   if(d.count() > 0)
    {
       for ( i=0; i<d.count(); i++ ){
                                       box->insertItem(d[i]);
                                    }
    }

}

void Adressbuch::boxNeu()
{
   lcd1->display(1);
   liste->clearSelection();
   listeninhalt();
}

void Adressbuch::listeninhalt()
{
    int i, j=0;
    const char string[29][9][40];


    for(i=0; i<=29; i++)
     {
       if(liste->isSelected(i))
         {
           j=i;
         }
     }

   lcd1->display(j+1);
   datenLaden(string);

   nachname->setText(string[j][0]);
   vorname->setText(string[j][1]);
   strasse->setText(string[j][2]);
   plz->setText(string[j][3]);
   ort->setText(string[j][4]);
   tel1->setText(string[j][5]);
   tel2->setText(string[j][6]);
   bem1->setText(string[j][7]);
   bem2->setText(string[j][8]);

}

void Adressbuch::datenLaden(const char string[][9][40])
{

  FILE* fp;
  char nam[29][40];
  int i, j;

  fp=fopen(box->currentText(),"rt");

  if(fp==NULL)
    {
       info2 = new QMessageBox( "Programmfehler", "In Deinem home-Verzeichnis wurde keine\nAdressbuchdatei gefunden!\nDu kannst jetzt eine erstellen!",
                           QMessageBox::Information,
                           0, 0, 0, this, "info2");
       printf("\nFehler beim ffnen!\n\n");
       info2->show();
       datAnlegenM();
    }

  if(fp != NULL)
   {
     j=0;
     do
     {
       for(i=0;i<=8;i++)
       {
         fgets(string[j][i],40,fp);
       }
       j++;

     }while(!feof(fp));

     fclose(fp);

     liste->clear();
     lcd2->display(j-1);

     for(i=0;i<=j-2;i++)
     {
        strcpy(nam[i], string[i][0]);
        strcat(nam[i], string[i][1]);
        liste->insertItem(nam[i]);
     }
   }



}

void Adressbuch::loeschenfn()
{
   int m, n;
   FILE* fp;
   const char string[29][9][40];

   datenLaden(string);

   fp=fopen(box->currentText(),"wt");

   for(m=0; m<=lcd2->value()-1; m++)
    {
      if(m != lcd1->value()-1)
      {
      	for(n=0;n<=8;n++)
	      {
	        fputs(string[m][n],fp);
	      }
      }
    }
   fclose(fp);
   m=0;
  listeninhalt();
}

void Adressbuch::neuer()
{

   if(strlen(titel->text()) == 15)
   {
    bereich1->hide();
    bereich2->hide();
    liste->hide();
    box->hide();
    lcd1->hide();
    lcd2->hide();
    loeschen->hide();
    speicher->hide();
    neuAdressbuch->hide();
    neuerEintrag->setText("OK");
    titel->setText("Eintragen und OK klicken!");
    nachname->clear();
    vorname->clear();
    strasse->clear();
    plz->clear();
    ort->clear();
    tel1->clear();
    tel2->clear();
    bem1->clear();
    bem2->clear();
    neuerEintrag->setGeometry( 20, 240, 110, 22 );

   } else
   {
    schreiben();
    bereich1->show();
    bereich2->show();
    liste->show();
    box->show();
    lcd1->show();
    lcd2->show();
    loeschen->show();
    speicher->show();
    neuAdressbuch->show();
    neuerEintrag->setText("Neu");
    titel->setText("Adressbuch 1.00");
    neuerEintrag->setGeometry( 12, 109, 40, 22 );
    listeninhalt();
   }
}

void Adressbuch::schreiben()
{
  FILE* fp;
  char s[40];

  fp=fopen(box->currentText(),"at");
  if(fp==NULL)
    {
      printf("\nFehler beim Anhngen!\n\n");
    }

    strcpy(s, nachname->text());
    strcat(s, "\r\n");
    if(strlen(nachname->text())< 2) strcpy(s,"...\r\n");
    fputs(s,fp);

    strcpy(s, vorname->text());
    strcat(s, "\r\n");
    if(strlen(vorname->text())< 2) strcpy(s,"...\r\n");
    fputs(s,fp);

    strcpy(s, strasse->text());
    strcat(s, "\n");
    if(strlen(strasse->text())< 2) strcpy(s,"...\n");
    fputs(s,fp);

    strcpy(s, plz->text());
    strcat(s, "\n");
    if(strlen(plz->text())< 2) strcpy(s,"...\n");
    fputs(s,fp);

    strcpy(s, ort->text());
    strcat(s, "\n");
    if(strlen(ort->text())< 2) strcpy(s,"...\n");
    fputs(s,fp);

    strcpy(s, tel1->text());
    strcat(s, "\n");
    if(strlen(tel1->text())< 2) strcpy(s,"...\n");
    fputs(s,fp);

    strcpy(s, tel2->text());
    strcat(s, "\n");
    if(strlen(tel2->text())< 2) strcpy(s,"...\n");
    fputs(s,fp);

    strcpy(s, bem1->text());
    strcat(s, "\n");
    if(strlen(bem1->text())< 2) strcpy(s,"...\n");
    fputs(s,fp);

    strcpy(s, bem2->text());
    strcat(s, "\n");
    if(strlen(bem2->text())< 2) strcpy(s,"...\n");
    fputs(s,fp);




  fclose(fp);
}

void Adressbuch::dateiAnlegen()
{
  FILE* fp;
  char buch[20];

  strcpy(buch, adrbuch->text());
  strcat(buch, ".chr");

  fp=fopen( buch, "at" );
  if(fp==NULL)
    {
      info3 = new QMessageBox( "Fehler", "Es konnte keine Datei angelegt werden!",
                           QMessageBox::Information,
                           0, 0, 0, this, "info3");

      info3->show();

    }

  fclose(fp);

  neubuch->hide();
  adrbuch->hide();
  anlegen->hide();
  bereich4->hide();
  abbrechen->hide();

  boxinhalt();
}

void Adressbuch::heileWelt()
{
    bereich1->show();
    bereich2->show();
    liste->show();
    box->show();
    lcd1->show();
    lcd2->show();
    loeschen->show();
    speicher->show();
    neuAdressbuch->show();

    neuerEintrag->setText("Neu");
    titel->setText("Adressbuch 1.00");
    neuerEintrag->setGeometry( 12, 109, 40, 22 );
    listeninhalt();
}

void Adressbuch::heileWelt2()
{
    neubuch->hide();
    adrbuch->hide();
    anlegen->hide();
    bereich4->hide();
    abbrechen->hide();
    boxinhalt();
}

void Adressbuch::datAnlegenM()
{
   /*QPainter paint;

   paint.begin( this );
   paint.drawLine( 220, 20, 370, 10 );
   paint.end();*/

   neubuch = new QLabel( " ", this, "neubuch" );
   neubuch->setGeometry( 5, 36, 440, 330 );
   neubuch->show();

   bereich4 = new QGroupBox( "Name des neuen Adressbuches", this, "neuadrbuch" );
   bereich4->setGeometry( 100, 150, 260, 110 );
   bereich4->show();

   adrbuch = new QLineEdit( this, "adrbuch" );
   adrbuch->setGeometry( 180, 175, 100, 25 );
   adrbuch->show();

   anlegen = new QPushButton( "Anlegen", this, "anlegen" );
   anlegen->setGeometry( 120, 220, 100, 30 );
   anlegen->show();

   abbrechen = new QPushButton( "Abbruch", this, "abbrechen" );
   abbrechen->setGeometry( 240, 220, 100, 30 );
   abbrechen->show();


   connect(anlegen, SIGNAL(clicked()), SLOT(dateiAnlegen()) );
   connect(abbrechen, SIGNAL(clicked()), SLOT(heileWelt2()) );

}

void Adressbuch::speichern()
{
   int m, n;
   FILE* fp;
   const char string[29][9][40];
   char s[40];
   int lenge;

   datenLaden(string);

   fp=fopen(box->currentText(),"wt");

   for(m=0; m<=lcd2->value()-1; m++)
    {
      if(m != lcd1->value()-1)
      {
      	for(n=0;n<=8;n++)
	      {
	        fputs(string[m][n],fp);
	      }
      } else
      {
       strcpy(s, nachname->text());
       lenge = strcspn(s, "\n");
       strncpy(s, s, lenge);
       s[lenge]='\0';
       strcat(s, "\n");
       if(strlen(nachname->text())< 2) strcpy(s,"...\n");
       fputs(s,fp);

       strcpy(s, vorname->text());
       lenge = strcspn(s, "\n");
       strncpy(s, s, lenge);
       s[lenge]='\0';
       strcat(s, "\n");
       if(strlen(vorname->text())< 2) strcpy(s,"...\n");
       fputs(s,fp);

       strcpy(s, strasse->text());
       lenge = strcspn(s, "\n");
       strncpy(s, s, lenge);
       s[lenge]='\0';
       strcat(s, "\n");
       if(strlen(strasse->text())< 2) strcpy(s,"...\n");
       fputs(s,fp);

       strcpy(s, plz->text());
       lenge = strcspn(s, "\n");
       strncpy(s, s, lenge);
       s[lenge]='\0';
       strcat(s, "\n");
       if(strlen(plz->text())< 2) strcpy(s,"...\n");
       fputs(s,fp);

       strcpy(s, ort->text());
       lenge = strcspn(s, "\n");
       strncpy(s, s, lenge);
       s[lenge]='\0';
       strcat(s, "\n");
       if(strlen(ort->text())< 2) strcpy(s,"...\n");
       fputs(s,fp);

       strcpy(s, tel1->text());
       lenge = strcspn(s, "\n");
       strncpy(s, s, lenge);
       s[lenge]='\0';
       strcat(s, "\n");
       if(strlen(tel1->text())< 2) strcpy(s,"...\n");
       fputs(s,fp);

       strcpy(s, tel2->text());
       lenge = strcspn(s, "\n");
       strncpy(s, s, lenge);
       s[lenge]='\0';
       strcat(s, "\n");
       if(strlen(tel2->text())< 2) strcpy(s,"...\n");
       fputs(s,fp);

       strcpy(s, bem1->text());
       lenge = strcspn(s, "\n");
       strncpy(s, s, lenge);
       s[lenge]='\0';
       strcat(s, "\n");
       if(strlen(bem1->text())< 2) strcpy(s,"...\n");
       fputs(s,fp);

       strcpy(s, bem2->text());
       lenge = strcspn(s, "\n");
       strncpy(s, s, lenge);
       s[lenge]='\0';
       strcat(s, "\n");
       if(strlen(bem2->text())< 2) strcpy(s,"...\n");
       fputs(s,fp);

      }

    }
   fclose(fp);
   m=0;
  listeninhalt();
}

void Adressbuch::mailen()
{
    KProcess mailprogramm;
    mailprogramm << "kmail" << bem1->text();
    mailprogramm.start(KProcess::DontCare,KProcess::Stdout);


}


