/***************************************************************************
                          main.cpp  -  description                              
                             -------------------                                         
    begin                : 10.11.1999                                          
    copyright            : (C) 1999 by Christoph Maciejewski                   
    email                : christophmac@01019freenet.de
                  
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "adressbuch.h"
#include <kapp.h>
#include <qobject.h>
#include <qpushbutton.h>
#include <qfont.h>
#include <qlineedit.h>
#include <qfiledialog.h>
#include <qlabel.h>
#include <qlistbox.h>
#include <qlcdnumber.h>
#include <qprogressbar.h>
#include <qmessagebox.h>
#include <qcombobox.h>
#include <qgroupbox.h>
#include <string.h>
#include <qdir.h>


Adressbuch::Adressbuch( QWidget *parent, const char *name )
        : QWidget( parent, name )
{
    setMinimumSize( 450, 350 );
    setMaximumSize( 450, 350 );

    titel = new QLabel( "Adressbuch 1.00", this, "titel" );
    titel->setGeometry( 30, 1, 190, 30 );
    titel->setFont( QFont( "Times", 16, QFont::Bold ) );

    quit = new QPushButton( "Beenden", this, "quit" );
    quit->setGeometry( 370, 3, 75, 30 );
    quit->setFont( QFont( "Times", 16, QFont::Bold ) );

    explore = new QPushButton( "Info", this, "explore" );
    explore->setGeometry( 290, 3, 75, 30 );
    explore->setFont( QFont( "Times", 16, QFont::Bold ) );

    cancel = new QPushButton( "Abbrechen", this, "cancel" );
    cancel->setGeometry( 20, 270, 110, 22);

    bereich1 = new QGroupBox( "Adressbuch", this, "adrbuch" );
    bereich1->setGeometry( 5, 35, 150, 50 );

    bereich2 = new QGroupBox( "Eintrge", this, "eintrag" );
    bereich2->setGeometry( 5, 90, 150, 250 );

    bereich3 = new QGroupBox( "Daten", this, "daten" );
    bereich3->setGeometry( 160, 35, 285, 305 );

    box = new QComboBox( FALSE, this, "box");
    box->setGeometry( 57, 53, 90, 25);

    liste = new QListBox( this, "liste" );
    liste->setGeometry( 12, 135, 136, 195 );

    lcd1 = new QLCDNumber( 2, this, "lcd1");
    lcd1->setGeometry( 80, 107, 30, 25);

    lcd2 = new QLCDNumber( 2, this, "lcd2");
    lcd2->setGeometry( 114, 107, 30, 25);

    nachname = new QLineEdit( this, "nachname" );
    nachname->setGeometry( 243, 70, 195, 25);
    vorname = new QLineEdit( this, "vorname" );
    vorname->setGeometry( 243, 100, 195, 25);
    strasse = new QLineEdit( this, "strasse" );
    strasse->setGeometry( 243, 130, 195, 25);
    plz = new QLineEdit( this, "plz" );
    plz->setGeometry( 243, 160, 195, 25);
    ort = new QLineEdit( this, "ort" );
    ort->setGeometry( 243, 190, 195, 25);
    tel1 = new QLineEdit( this, "tel1" );
    tel1->setGeometry( 243, 220, 195, 25);
    tel2 = new QLineEdit( this, "tel2" );
    tel2->setGeometry( 243, 250, 195, 25);
    bem1 = new QLineEdit( this, "bem1" );
    bem1->setGeometry( 243, 280, 195, 25);
    bem2 = new QLineEdit( this, "bem2" );
    bem2->setGeometry( 243, 310, 195, 25);

    email = new QPushButton( "eMail", this, "email" );
    email->setGeometry( 170, 280, 65, 25 );

    loeschen = new QPushButton( "Karte lschen", this, "loeschen" );
    loeschen->setGeometry( 244, 48, 95, 18 );

    speicher = new QPushButton( "Speichern", this, "speichern" );
    speicher->setGeometry( 344, 48, 95, 18 );

    neuerEintrag = new QPushButton( "Neu", this, "neurEintrag" );
    neuerEintrag->setGeometry( 12, 109, 40, 22 );

    neuAdressbuch = new QPushButton( "Neu", this, "neuAdressbuch" );
    neuAdressbuch->setGeometry( 12, 55, 40, 22 );

    label = new QLabel( "Nachname\n\nVorname\n\nStrasse\n\nPLZ\n\nOrt\n\nTelefon1\n\nTelefon2", this, "titel" );
    label->setGeometry( 170, 70, 70, 200 );


    boxinhalt();
    listeninhalt();


    connect(quit, SIGNAL(clicked()), qApp, SLOT(quit()) );
    connect(speicher, SIGNAL(clicked()), SLOT(speichern()) );
    connect(neuAdressbuch, SIGNAL(clicked()), SLOT(datAnlegenM()) );
    connect(cancel, SIGNAL(clicked()), SLOT(heileWelt()) );
    connect(explore, SIGNAL(clicked()), SLOT(information()) );
    connect(box, SIGNAL(activated(int)), SLOT(boxNeu()) );
    connect(loeschen, SIGNAL(clicked()), SLOT(loeschenfn()) );
    connect(liste, SIGNAL(selected(int)), SLOT(listeninhalt()) );
    connect(neuerEintrag, SIGNAL(clicked()), SLOT(neuer()) );
    connect(email, SIGNAL(clicked()), SLOT(mailen()) );

}





int main(int argc, char* argv[])
{
  KApplication a(argc,argv,"adressbuch");  
  
  Adressbuch* adressbuch = new Adressbuch;
  a.setMainWidget(adressbuch);
  adressbuch->show();  
  return a.exec();
}

void Adressbuch::paintEvent( QPaintEvent * )
{
  //QPainter paint( this );
  //int i;

  //paint.drawLine( 220, 20, 250, 20 ); // draw line
  //paint.drawRect( 220, 10, 50, 20 );
}



